#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#define DEV "/dev/pc26at"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>   
#include <unistd.h>
#include "pc26at.h" 
ssize_t read(int fd, void *buf, size_t count);  

#define N 128*1024/4

main(){
FILE	*fo;
int	fio;
float	data[N];
char 	channels[20];
long	n=0,i;
	printf("Matts device tester\n");
	printf("About to open %s\n",DEV);
        fio=open(DEV,O_RDWR); 
	if(fio==-1){
		printf("Failed to open %s\n",DEV);
		perror("TestDev error:");
		exit(1);
		}
	printf("Trying to set the channel list to channel 0\n");
	channels[0]=5;
	write(fio,channels,1);
	printf("About to set the clock to 40kHz\n");
	n=ioctl(fio,PC26AT_HZ,40000);
	printf("Done... got %d\n",(int)n);
	printf("About to enable interrupts\n");
	n=ioctl(fio,PC26AT_TRIG_INT,0);
	printf("Done... got %d\n",(int)n);
	
	printf("About to attempt to read 100 floats\n");
	n=(int)read(fio,(void *)data,sizeof(float)*100);
	printf("Read %d floats\n",n);
	for(i=0;i<100;i++){
		printf("%d: v=%f\n",i,data[i]);
		}
	printf("About to write channel 0\n");
	for(i=0;i<20;i++)channels[i]=i;
	channels[0]=5;// quick hack
	n=(int)write(fio,(void *)channels,sizeof(char)*1);
	printf("Wrote %d bytes\n",n);

	printf("About to attempt to read %d floats\n",N);
	n=(long)read(fio,(void *)data,sizeof(float)*N);
	printf("Read %d floats\n",n/sizeof(float));
	printf("About to save this data to file test_int.dat\n");
	fo=fopen("test_int.dat","w");
	fwrite(data,sizeof(float),N,fo);
	fclose(fo);
	printf("done\n");

	}	
