#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#define DEV "/dev/pc26at"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>   
#include <unistd.h>
 
ssize_t read(int fd, void *buf, size_t count);  

#define N 128*1024/4

main(){
int	fio;
float	data[N];
char 	channels[20];
long	n=0,i;
	printf("Matts device tester\n");
	printf("About to open %s\n",DEV);
        fio=open(DEV,O_RDWR); 
	if(fio==-1){
		printf("Failed to open %s\n",DEV);
		perror("TestDev error:");
		exit(1);
		}
	printf("Trying to set the channel list to channel 0\n");
	channels[0]=0;
	write(fio,channels,1);
	printf("About to attempt to read 100 floats\n");
	n=(int)read(fio,(void *)data,sizeof(float)*100);
	printf("Read %d floats\n",n);

	printf("About to write channels 0-7\n");
	for(i=0;i<20;i++)channels[i]=i;
	n=(int)write(fio,(void *)channels,sizeof(char)*8);
	printf("Wrote %d bytes\n",n);

	printf("About to attempt to read %d floats\n",N);
	n=(long)read(fio,(void *)data,sizeof(float)*N);
	printf("Read %d floats\n",n/sizeof(float));

	}	
